#include "../port/portfns.h"

/* functions and macros used by port code */
void 		coherence(void);
ulong	tas(ulong*);
void		evenaddr(ulong);
void		procsetup(Proc*);
void		procsave(Proc*);
void		procrestore(Proc*);
void		cycles(uvlong*);

#define	waserror()		(up->nerrlab++, setlabel(&up->errlab[up->nerrlab-1]))
#define	userureg(ur)	(((ur)->pstate & PSPRIV) == 0)

#define 	KADDR(pa)	((void*)((ulong)(pa)|KZERO))
#define 	PADDR(va)	((ulong)(va)&~KZERO)
#define	kmapinval()
#define	VA(k)			((ulong)(k))
#define	idlehands()



/* functions and macros used only in this directory */
void putasi4(uchar, ulong, ulong);
void putasi8(uchar, ulong, uvlong);
ulong getasi4(uchar, ulong);
uvlong getasi8(uchar, ulong);
void put8(ulong, uvlong);
uvlong get8(ulong);
uvlong gettick(void);
int gettl(void);
ulong getsoftint(void);
void puttickcmp(uvlong);
void intrraise(ulong);
void intrclear(ulong);
void intrenable(void);
void intrdisable(void);
void icflush(ulong);
void puttba(ulong);
ulong getpil(void);
ulong getpstate(void);
int ofcall(void *);
void touser(ulong);
void traplink(void);
void syslink(void);
void restorefpregs(FPsave*);
void reset(void);

void clockinit(void);
void clockintr(Ureg*);

void z8530init(void);
int z8530intr(void);
void hmeintr(void);
void fas366intr(void);
void links(void);

void mmuinit(void);
KMap *kmapphys(uvlong, int, ulong);
void putkdtlb(ulong, uvlong);
KMap *kmap(Page *);
void kunmap(KMap *);
int kmapsync(ulong);

void trapinit(void);
void trap(Ureg *);
void sbusenableintr(ulong);
void sbusenabledma(int);
long syscall(Ureg *);
void fppause(void);
void trapcritical(ulong, ulong, ulong);

int offinddevice(char *);
int ofgetprop(int, char *, void *, int);
int ofgetdevprop(char*, char*, void *, int);
int ofwrite(int, void *, int);

char* getconf(char*);

/* XXX DEBUG */
extern void (*xputcfunc)(int);
extern int xputcCR;
void zsetdev(ulong);
void xwrite(void*, int);
void xprint(char *, ...);
void xputs(char *, int);
