/*
 * a home for v9 instructions that arent supported by ka.
 */

#define NOOP	ORN R0,R0

#define rdr1r2(rd,r1,r2)	(((rd)<<25) | ((r1)<<14) | (r2))
#define rdr1r2as(rd,r1,r2,as)	(rdr1r2(rd,r1,r2) | ((as)<<5))
#define rdr1im(rd,r1,im)	(((rd)<<25) | ((r1)<<14) | ((im) & 0x1fff) | 0x2000)

#define CASAr(rd,r1,r2,as) WORD $(0xc1e00000 | rdr1r2as(rd,r1,r2,as))
#define CASXAr(rd,r1,r2,as) WORD $(0xc1f00000 | rdr1r2as(rd,r1,r2,as))
#define LDWAi(rd,r1,im)	WORD $(0xc0800000 | rdr1im(rd,r1,im))
#define LDXr(rd,r1,r2)	WORD $(0xc0580000 | rdr1r2(rd,r1,r2))
#define LDXi(rd,r1,im)	WORD $(0xc0580000 | rdr1im(rd,r1,im))
#define LDXAr(rd,r1,r2,as) WORD $(0xc0d80000 | rdr1r2as(rd,r1,r2,as))
#define LDXAi(rd,r1,im)	WORD $(0xc0d80000 | rdr1im(rd,r1,im))
#define LDXFSRr(rd,r1,r2)	WORD $(0xc1080000 | rdr1r2(rd,r1,r2))
#define LDXFSRi(rd,r1,im) WORD $(0xc1080000 | rdr1im(rd,r1,im))
#define DONE			WORD $0x81f00000
#define RETRY			WORD $0x83f00000
#define FLUSHr(r1, r2)	WORD $(0x81d80000 | rdr1r2(0,r1,r2))
#define FLUSHi(r1,im)	WORD $(0x81d80000 | rdr1im(0,r1,im))
#define MEMBAR(t)		WORD $(0x8143e000 | t)
#define MOVRr(rd,r1,r2,rcond) WORD $(0x81780000 | rdr1r2(rd,r1,r2) | (rcond<<10))
#define MOVRi(rd,r1,im,rcond) WORD $(0x81780000 | rdr1im(rd,r1,im) | (rcond<<10))
#define RDPR(rd,r1)		WORD $(0x81500000 | rdr1r2(rd,r1,0))
#define RDST(rd,r1)		WORD $(0x81400000 | rdr1r2(rd,r1,0))
#define SLLXr(rd,r1,r2)	WORD $(0x81281000 | rdr1r2(rd,r1,r2))
#define SLLXi(rd,r1,im)	WORD $(0x81281000 | rdr1im(rd,r1,im))
#define SRLXr(rd,r1,r2)	WORD $(0x81301000 | rdr1r2(rd,r1,r2))
#define SRLXi(rd,r1,im)	WORD $(0x81301000 | rdr1im(rd,r1,im))
#define SRLAr(rd,r1,r2)	WORD $(0x81381000 | rdr1r2(rd,r1,r2))
#define SRLAi(rd,r1,im)	WORD $(0x81381000 | rdr1im(rd,r1,im))
#define SIR			WORD $0x9f002000
#define STWAi(rd,r1,im)	WORD $(0xc0a00000 | rdr1im(rd,r1,im))
#define STXr(rd,r1,r2)	WORD $(0xc0700000 | rdr1r2(rd,r1,r2))
#define STXi(rd,r1,im)	WORD $(0xc0700000 | rdr1im(rd,r1,im))
#define STXAr(rd,r1,r2,as) WORD $(0xc0f00000 | rdr1r2as(rd,r1,r2,as))
#define STXAi(rd,r1,im)	WORD $(0xc0f00000 | rdr1im(rd,r1,im))
#define WRPRr(rd,r1,r2)	WORD $(0x81900000 | rdr1r2(rd,r1,r2))
#define WRPRi(rd,r1,im)	WORD $(0x81900000 | rdr1im(rd,r1,im))
#define WRSTr(rd,r1,r2)	WORD $(0x81800000 | rdr1r2(rd,r1,r2))
#define WRSTi(rd,r1,im)	WORD $(0x81800000 | rdr1im(rd,r1,im))

/* ultrasparc specific */
#define SHUTDOWN		WORD $0x81b01000

/* membar flags */
#define MBLOADLOAD	0x1	
#define MBSTORELOAD	0x2
#define MBLOADSTORE	0x4
#define MBSTORESTORE	0x8
#define MBLOOKASIDE	0x10
#define MBISSUE		0x20
#define MBSYNC		0x40

/* priv regs */
#define RTPC		0
#define RTNPC		1
#define RTSTATE	2
#define RTT		3
#define RTICK		4
#define RTBA		5
#define RPSTATE	6
#define RTL		7
#define RPIL		8
#define RCWP		9
#define RCANSAVE	10
#define RCANRESTORE	11
#define RCLEANWIN	12
#define ROTHERWIN	13
#define RWSTATE	14
#define RFQ		15

/* state registers */
#define RY		0
#define RCCR		2
#define RASI		3
//#define RTICK		4
#define RPC		5
#define RFPRS		6
#define RSETINT	0x14			/* non-v9 */
#define RCLRINT	0x15			/* non-v9 */
#define RSOFTINT	0x16			/* non-v9 - software interrupt */
#define RTICKCMP	0x17			/* non-v9 - tick compare register */

/* rcond values for MOVR */
#define RCOND_Z	1
#define RCOND_LEZ	2
#define RCOND_LZ	3
#define RCOND_NZ	5
#define RCOND_GZ	6
#define RCOND_GEZ 7

