
#define	SBUS			0x1fe00000000LL	/* sbus and iommu registers */
#define	HME			0x1ffe8c00000LL	/* ethernet */
#define	SCSIDMA		0x1ffe8800000LL	/* feps scsi dma controller */
#define	SCSI			0x1ffe8810000LL	/* fas366 scsi controller */
#define	KMDUART		0x1fff1000000LL	/* keyboard/mouse uart */
#define	KMFREQ		78500000		/* found experimentally.. Documented somewhere? */
#define	EIADUART		0x1fff1100000LL	/* ttyA/ttyB uart */
#define	EIAFREQ		5000000			/* XXX likely wrong */
#define	EEPROM		0x1fff1200000LL	/* eeprom/rtc */

extern ulong sbusreg;
extern ulong iommureg;

enum { 
	SbusIntrMapLo = 0x3000,
	SbusIntrMapHi = 0x3090,
	SbusIntrClrLo = 0x3800,

	/* interrupt vectors and map/clr registers */
	SbusIntrScsi = 0x7e0,
	SbusIntrMapScsi = 0x3000,
	SbusIntrClrScsi = 0x3800,

	SbusIntrHme = 0x7e1,
	SbusIntrMapHme = 0x3008,
	SbusIntrClrHme = 0x3808,

	SbusIntrSerial = 0x7e8,
	SbusIntrMapSerial = 0x3028,
	SbusIntrClrSerial = 0x3828,

	SbusIntrTimer1 = 0x7f1,

	/* SBUS slot offsets (not identical to slot #) */
	SbusFeps = 5,
};

