
#include <u.h>
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"

static int stdout = 0;

int
offinddevice(char *device)
{
	static struct {
		int p0;
		char *name;
		int p1, nargs;
		int p2, nreturns;
		int p3, device;
		int p4, phandle;
	} args = {
		0, "finddevice", 0, 1, 0, 1
	};

	args.device = (int)device;
	ofcall(&args);
	return args.phandle;
}

int
ofgetprop(int handle, char *prop, void *buf, int buflen)
{
	static struct {
		int p0;
		char *name;
		int p1, nargs;
		int p2, nreturns;
		int p3, phandle;
		int p4, prop;
		int p5, buf;
		int p6, buflen;
		int p7, size;
	} args = {
		0, "getprop", 0, 4, 0, 1
	};

	args.phandle = handle;
	args.prop = (int)prop;
	args.buf = (int)buf;
	args.buflen = buflen;
	ofcall(&args);
	return args.size;
}

int
ofwrite(int handle, void *addr, int len)
{
	static struct {
		int p0;
		char *name;
		int p1, nargs;
		int p2, nreturns;
		int p3, ihandle;
		int p4, addr;
		int p5, len;
		int p6, actual;
	} args = {
		0, "write", 0, 3, 0, 1
	};

	args.ihandle = handle;
	args.addr = (int)addr;
	args.len = len;
	ofcall(&args);
	return args.actual;
}

int
ofgetdevprop(char* dev, char* prop, void *buf, int buflen)
{
	int devno;

	devno = offinddevice(dev);
	if(devno == -1)
		return -1;
	return ofgetprop(devno, prop, buf, buflen);
}

static void
ofputc(int c)
{
	int dev;

	if(!stdout) {
		dev = offinddevice("/chosen");
		ofgetprop(dev, "stdout", &stdout, sizeof stdout);
		ofwrite(stdout, "\r\n", 2);
	}
	ofwrite(stdout, &c, 1);
}


